================================================================================
Introduction
================================================================================

Ka0s Leaderboard is an app for Assetto Corsa which aims to bring comprehensive in-game live timing into the game. Unlike apps like Rivali Tempo and RSR, this app will not push data to an external website for later analysis - Rivali and RSR do a fantastic job of that already. Instead, it will focus solely on in-game data display, with the long term objective of replacing the default leaderboard (which you get when you press TAB).

Instead of typing a wall of text explaining what the app does, just watch the video below and see for yourself (watch in HD Fullscreen) - keep in mind that the demo video showcases ALL of the information the app is capable of displaying - a typical setup will be much more condensed (see Sample Configurations section)

Youtube Link : https://www.youtube.com/watch?v=ZheV_8vdJSI

Apologies for the poor driving, I'm fairly new to sim racing ...

================================================================================
Changes in Latest Version (0.2.0 | 26-Jun-2014)
================================================================================

[*]Added color settings for header, alternate rows and best/worst for selected columns in config.py
[*]Fixed restart bug where some columns were not getting reset when you restarted a race
[*]Get car name from Assetto Corsa car data files
[*]Added columns (i) Lap Distance (ii) Race Distance (iii) Distance Delta for Lead/Previous/You (iv) Current Speed (v) Top Speed
[*]Added settings to refresh app display every 'x' frames
[*]Code cleanup for efficiency

================================================================================
Installation
================================================================================

[*]Download the latest file from http://www.nexusmods.com/assettocorsa/mods/1/
[*]Extract the contents of the archive into your main Assetto Corsa folder (typically SteamApps\common\assettocorsa\)
[*]In-game (during a session), move your mouse towards the right of the screen and click on the "K" icon shown below

K Icon : http://i.imgur.com/MLuWBC7.png

================================================================================
Configuration
================================================================================

You can configure many aspects of the app directly in the code (Configuration GUI is Coming Soon ™).

Head over to assettocorsa\apps\python\ka0sleaderboard\src\config.py and tinker away to your heart's content. There are pretty detailed comments inside the file itself, explaining what the various options do.

You can :

[*]Change the font size and window opacity
[*]Change the colors being used for various features
[*]Adjust the number of rows being displayed
[*]Modify which columns are displayed, and the order in which they are displayed

And more!

================================================================================
Sample Configurations And Screenshots
================================================================================

----------------------------------------
Default Layout
----------------------------------------
------------------
Image
------------------
http://i.imgur.com/2hjiMuV.jpg
------------------
Layout Code
------------------
COLUMN_LAYOUT = ['COL_POSITION', 'COL_NAME', 'COL_LAPS', 'COL_COMPLETION_LAP', 'COL_DIFF_TIME_LEAD', 'COL_DIFF_DISTANCE_LEAD', 'COL_SPLIT', 'COL_CURR_LAP', 'COL_LAST_LAP', 'COL_BEST_LAP']

----------------------------------------
All Columns Layout with Speed Unit = KMH
----------------------------------------
------------------
Image
------------------
http://i.imgur.com/TRAoEzZ.jpg
------------------
Layout Code
------------------
COLUMN_LAYOUT = ['COL_POSITION', 'COL_NAME', 'COL_CAR', 'COL_LAPS', 'COL_COMPLETION_LAP', 'COL_DISTANCE_LAP', 'COL_COMPLETION_RACE', 'COL_DISTANCE_RACE', 'COL_DIFF_TIME_LEAD', 'COL_DIFF_TIME_PREV', 'COL_DIFF_TIME_YOU', 'COL_DIFF_DISTANCE_LEAD', 'COL_DIFF_DISTANCE_PREV', 'COL_DIFF_DISTANCE_YOU', 'COL_SPLIT', 'COL_CURR_LAP', 'COL_LAST_LAP', 'COL_BEST_LAP', 'COL_SPEED_CURRENT', 'COL_SPEED_MAX']

----------------------------------------
All Columns Layout with Speed Unit = MPH
----------------------------------------
------------------
Image
------------------
http://i.imgur.com/02OhmQn.jpg
------------------
Layout Code
------------------
COLUMN_LAYOUT = ['COL_POSITION', 'COL_NAME', 'COL_CAR', 'COL_LAPS', 'COL_COMPLETION_LAP', 'COL_DISTANCE_LAP', 'COL_COMPLETION_RACE', 'COL_DISTANCE_RACE', 'COL_DIFF_TIME_LEAD', 'COL_DIFF_TIME_PREV', 'COL_DIFF_TIME_YOU', 'COL_DIFF_DISTANCE_LEAD', 'COL_DIFF_DISTANCE_PREV', 'COL_DIFF_DISTANCE_YOU', 'COL_SPLIT', 'COL_CURR_LAP', 'COL_LAST_LAP', 'COL_BEST_LAP', 'COL_SPEED_CURRENT', 'COL_SPEED_MAX']
SPEED_UNIT = SPEED_UNIT_MPH

----------------------------------------
Minimal Layout
----------------------------------------
------------------
Image
------------------
http://i.imgur.com/JHw3etr.jpg
------------------
Layout Code
------------------
COLUMN_LAYOUT = ['COL_POSITION', 'COL_NAME', 'COL_DIFF_TIME_LEAD']

----------------------------------------
Drag Race Layout
----------------------------------------
------------------
Image
------------------
http://i.imgur.com/ekboJQM.jpg
------------------
Layout Code
------------------
NUMBER_OF_ROWS = 2
COLUMN_LAYOUT = ['COL_POSITION', 'COL_NAME', 'COL_CURR_LAP', 'COL_DIFF_TIME_LEAD', 'COL_DIFF_DISTANCE_LEAD', 'COL_SPEED_CURRENT', 'COL_SPEED_MAX']

----------------------------------------
Random Psychedelic Colors Layout
----------------------------------------
------------------
Image
------------------
http://i.imgur.com/pm7mKAZ.jpg
------------------
Layout Code
------------------
# Color settings for header
COLOR_FOREGROUND_HEADER = RGB(255, 255, 255)
COLOR_BACKGROUND_HEADER = RGB(255, 0, 0)
OPACITY_BACKGROUND_HEADER = 1.0

# Color settings for odd rows (1,3,5,7...)
COLOR_FOREGROUND_ROW_1 = RGB(255, 255, 255)
COLOR_BACKGROUND_ROW_1 = RGB(0, 0, 255)
OPACITY_BACKGROUND_ROW_1 = 1.0

# Color settings for odd rows (2,4,6,8...)
COLOR_FOREGROUND_ROW_2 = RGB(255, 255, 255)
COLOR_BACKGROUND_ROW_2 = RGB(0, 0, 255)
OPACITY_BACKGROUND_ROW_2 = 1.0

# Color settings for self
COLOR_FOREGROUND_SELF = RGB(255, 255, 255)
COLOR_BACKGROUND_SELF = RGB(255, 255, 0)
OPACITY_BACKGROUND_SELF = 1.0

================================================================================
Known Issue
================================================================================

*** The app does not current work in multi-player races. ***

This is due to a bug in the API which does not record all data in MP races. Rombik has filed a bug report for this here, but no luck yet =( The devs are aware of this, so hopefully this gets fixed soon. This is Early Access after all, so have patience =)

------------------------------------
Bug Report
http://www.assettocorsa.net/forum/index.php?threads/python-api-doesnt-return-laptime-lastsplits-bestlap-lapcount-for-other-cars-id-0-in-mp.9641/
------------------------------------

*** Python API doesn't return LapTime, lastSplits, BestLap, LapCount for other cars (id != 0) in MP ***

This info is a must have for apps which show timing, positions, delta etc.
Btw, API for NormalizedSplinePosition, DriverName, etc works fine.

PS
I understand that this is low priority and related to "Programming Language - Apps - GUI Themes" forum, but it seems like that forum is ignored by developers.

================================================================================
Credits
================================================================================

This app is heavily inspired by Rombik's Race Delta app, and uses a lot of the same codebase (with his permission ofc). Big thank you!

ROMBIK : http://www.assettocorsa.net/forum/index.php?members/rombik.7083/
RACE DELTA : http://www.assettocorsa.net/forum/index.php?threads/race-delta-live-lap-timing-and-delta-for-race-and-qualification.10226/

================================================================================
TODO
================================================================================

[*]GUI configuration
[*]Lap mode for all drivers - show all laps for all drivers (useful for hotlap/practice)
[*]Pit/Invalid lap/etc indicator
[*]Add columns for current lap delta and projected lap time for on current lap
[*]Drift points column
[*]Bugfixes in replay/drag/drift mode

And more as I can think of stuff! Suggestions are also welcome of course =)

================================================================================
Changelog
================================================================================

------------------------------------
v0.2.0 | 26-Jun-2014
------------------------------------

[*]Added color settings for header, alternate rows and best/worst for selected columns in config.py
[*]Fixed restart bug where some columns were not getting reset when you restarted a race
[*]Get car name from Assetto Corsa car data files
[*]Added columns (i) Lap Distance (ii) Race Distance (iii) Distance Delta for Lead/Previous/You (iv) Current Speed (v) Top Speed
[*]Added settings to refresh app display every 'x' frames
[*]Code cleanup for efficiency

------------------------------------
v0.0.1 | 22-Jun-2014
------------------------------------

[*]Initial release. Yay!
