# !/usr/bin/env python
# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------
# Title       : appleaderboard.py
# Author      : aDd1kTeD2Ka0s (add1kted2ka0s@gmail.com)
# Date        : 20-Jun-2014
# Description : Ka0s Leaderboard - Main AC application for leaderboard
#             : Original code by Rombik
# -----------------------------------------------------------------------------

# -------------------------------------
# Imports
# -------------------------------------

# Add User home directory to path
import sys

sys.path.insert(0, 'apps/python/ka0sleaderboard/klb/dll')

# Import log_trackback
from klb.lib.utils import log_traceback

try:
	from klb.src.appdata import app_data
	from klb.src.appleaderboard import app_leaderboard
	from klb.src.applaps import app_laps
except:
	log_traceback()
	raise

# -------------------------------------
# Globals
# -------------------------------------

MAIN_APP_NAME = 'ka0sleaderboard'

#-------------------------------------
def acMain(ac_version):
	#-------------------------------------
	try:
		app_leaderboard.on_startup(ac_version)
		app_laps.on_startup(ac_version)
		return (MAIN_APP_NAME)
	except Exception:
		log_traceback()
		raise

# -------------------------------------
def acUpdate(dt):
	# -------------------------------------
	try:
		app_data.on_update(dt)
		app_leaderboard.on_update(dt)
		app_laps.on_update(dt)
	except Exception:
		log_traceback()
