# !/usr/bin/env python
# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------
# Title       : colors.py
# Author      : aDd1kTeD2Ka0s (add1kted2ka0s@gmail.com)
# Date        : 20-Jun-2014
# Description : Ka0s Leaderboard - Colors
#             : Original code by Rombik
# -----------------------------------------------------------------------------

# -------------------------------------
# Imports
# -------------------------------------

from collections import namedtuple

# -------------------------------------
class FloatRGB(namedtuple('FloatRGB', 'red green blue')):
	# -------------------------------------

	# -------------------------------------
	def __new__(self, r, g, b):
		# -------------------------------------
		return super().__new__(self, r, g, b)

# -------------------------------------
def RGB(r, g, b):
	# -------------------------------------
	return FloatRGB(r / 255.0, g / 255.0, b / 255.0)

# -------------------------------------
# Globals
# -------------------------------------

BLACK = RGB(0, 0, 0)
WHITE = RGB(255, 255, 255)
BRONZE = RGB(205, 127, 50)
SILVER = RGB(192, 192, 192)
GOLD = RGB(255, 215, 0)
PALE_RED = RGB(153, 127, 127)
RED = RGB(191, 0, 0)
LIGHT_RED = RGB(255, 191, 191)
GREEN = RGB(0, 191, 0)
DARK_GREEN = RGB(0, 64, 0)
