# !/usr/bin/env python
# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------
# Title       : appdata.py
# Author      : aDd1kTeD2Ka0s (add1kted2ka0s@gmail.com)
# Date        : 20-Jun-2014
# Description : Ka0s Leaderboard - AC application - Data to be used by GUI Apps
#             : Original code by Rombik
# -----------------------------------------------------------------------------

# -------------------------------------
# Imports
# -------------------------------------

import ac
import time

from .config import *
from .cars import Cars
from ..lib.utils import log

# -------------------------------------
class AppData():
	# -------------------------------------

	# -------------------------------------
	def __init__(self):
		# -------------------------------------
		self.last_timestamp = 0
		self.cars = Cars()

	# -------------------------------------
	def on_update(self, dt):
		# -------------------------------------
		# Refresh display only every UPDATE_FREQUENCY milliseconds
		current_timestamp = time.time()
		if (current_timestamp - self.last_timestamp) < UPDATE_FREQUENCY:
			return
		self.last_timestamp = current_timestamp

		# Update cars
		self.cars.on_update(dt, include_leader=True, limit=NUMBER_OF_ROWS_APP_LEADERBOARD)

# -------------------------------------
# Main
# -------------------------------------
app_data = AppData()
